#include<iostream>
using namespace std;
int main() {
	//get the number of items and the knapsack capacity
	int n, B;
	cin>>n>>B;
	//get the weight of items
	int* weight=new int[n];
	for(int i=0; i<n; i++) {
		int tempWeight;
		cin>>tempWeight;
		weight[i]=tempWeight;
	}
	//get the value of items
	int* value=new int[n];
	for(int i=0; i<n; i++) {
		int tempValue;
		cin>>tempValue;
		value[i]=tempValue;
	}
	//get the number of candidates
	int k;
	cin>>k;
	//initialize the best solution
	int bestIndex=0;
	int bestValue=-1;
	int bestWeight=0;
	//compare each candidates
	for(int i=0; i<k; i++) {
		//get the index of the current candidate
		int m;
		cin>>m;
		//get what items the current candidate choose
		//then compute the total weight and the total value of the current candidate
		int tempValue=0;
		int tempWeight=0;
		for(int j=0; j<n; j++) {
			bool choose;
			cin>>choose;
			if(choose) {
				tempValue+=value[j];
				tempWeight+=weight[j];
			}
		}
		//if total weight is valid, compare the value of the best solution with the value of the current candidate
		//if the current candidate's value is better than the highest value of all pre-evaluated candidates, this candidate becomes the new best
		if(tempWeight<=B&&tempValue>bestValue) {
			bestIndex=m;
			bestValue=tempValue;
			bestWeight=tempWeight;
		}
	}
	cout<<bestIndex<<" "<<bestWeight<<" "<<bestValue<<endl;
	return 0;
}
